#
# Bintree.pm : 񕪒T؁iIuWFNg̃eXgj
#
# i[f[^̓IuWFNgł邱
#
package Bintree;

# I[ nil pnbV
$nil = {};
bless $nil, 'Bintree';

# 񕪖؂ɏ
sub make_tree { $nil; }

# 񕪖؂̒T
sub search_tree {
  my ($node, $item) = @_;
  while( $node != $nil ){
    my $result = $item->compare( $node->{'item'} );
    if( $result == 0 ){
      return 1;
    } elsif( $result < 0 ){
      $node = $node->{'left'};
    } else {
      $node = $node->{'right'};
    }
  }
  0;
}
  
# f[^̒ǉ
sub insert_tree {
  my ($node, $item) = @_;
  if( $node == $nil ){
    my $new = {'item' => $item, 'left' => $nil, 'right' => $nil };
    bless $new, 'Bintree';
    return $new;
  } else {
    my $result = $item->compare( $node->{'item'} );
    if( $result < 0 ){
      $node->{'left'} = &insert_tree( $node->{'left'}, $item );
    } elsif( $result > 0 ){
      $node->{'right'} = &insert_tree( $node->{'right'}, $item );
    }
  }
  $node;
}

# 񕪖؂̕\
sub print_tree {
  my $node = shift;
  if( $node != $nil ){
    &print_tree( $node->{'left'} );
    $node->{'item'}->print_object();
    &print_tree( $node->{'right'} );
  }
}

1;

# end of file

