#include	"JX250.H"
#include	<sys\iocs.h>
#include	<sys\dos.h>
#include	<sys\scsi.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<io.h>
#include	<_tnb.c>

struct	HEN {
	UNchar	*st;
	int	*po;
} hen[]={
	{"SCSI-ID",		&SCSI_ID},
	//--- vW
	{"Pre-X1",		&PreX1},
	{"Pre-X2",		&PreX2},
	{"Pre-Y1",		&PreY1},
	{"Pre-Y2",		&PreY2},
	{"Pre-Mag",		&PreBai},	// 0;W 1;x2 2;x3 3;x4
	{"Pre-ViewX",		&PrePX},	// g\̎̃C[W\W
	{"Pre-ViewY",		&PrePY},
	{"Pre-Speed",		&PreViewS},	// 0;掿B1;x
	//--- XLTCY
	{"Scan-X",		&ScanDotX},
	{"Scan-Y",		&ScanDotY},
	{"ScanDPI-X",		&ScanDpiX},
	{"ScanDPI-Y",		&ScanDpiY},
	{"Scan-Speed",		&ScanSpeed},	// 0;ᑬB1;x
	//--- ␳
	{"Bright",		&Bright},	// Zx
	{"Light-M",		&LightM},	// x
	{"Light-R",		&LightR},
	{"Light-G",		&LightG},
	{"Light-B",		&LightB},
	{"Gamma-M",		&GammaM},	// 
	{"Gamma-R",		&GammaR},
	{"Gamma-G",		&GammaG},
	{"Gamma-B",		&GammaB},
	{"Thre-M",		&ThreM},	// l
	{"Thre-R",		&ThreR},
	{"Thre-G",		&ThreG},
	{"Thre-B",		&ThreB},
	//--- [h
	{"Scan-Mode",		&ScanMode},	// XLl̒P 0;DPI 1;DOT
	{"Pre-Unit",		&PreUnit},	// vXLl̒P 0;dot 1;cm 2;inch
	{"Image-Mode",		&ImageMode},	// 0;J[ 1;
	{"Image-Color",		&ImageColMode},	// 0;l 1;l
	{"Image-Direc",		&ImageDirec},	// 0;c 1;
	{"Poji-Nega",		&PojiNegaMode},	// 0;|W 1;lK
	{"Drop-Color",		&DropColor},	// 0;Ȃ 1;q 2;f 3;a
	{"FullCol-Mode",	&FullColor},	// 0;64k 1;24bit
	{"HalfDisp-Mode",	&C64halfMode},	// 0;ԏ 1;Ȃ
	{"Jpeged-Use",		&JpegedUseMode}, // 0;64k ̎gp 1;gpȂ
	{"SaveFrm-Mode",	&SaveFrmMode},	// 0;XLނɕύX
//	{"ReadPacket-Mode",	&ReadPacketMode}, // 0;ꊇ 1;
	//--- ̑
	{"Asp-Mode",		&AspMode},	//u摜v 0;(2:3) 1;(1:1)
	{"FilerSort-Mode",	&FilerSortMode}, // 0;dir 1;filename
	{"FilerAll-Mode",	&FilerAllMode},	// 0;֌Wt@Ĉݕ\ 1;St@C\
	//--- L^[h
	{"Rec-X1",		&RecX1},
	{"Rec-Y1",		&RecY1},
	{"Rec-X2",		&RecX2},
	{"Rec-Y2",		&RecY2},
	//--- 摜[h
	{"Img-Mag",		&RecVwBai},	// 0;x1  1;x2  2;x4 3;x8
						//-1;/2 -2;/4 -3;/8
	{"Save-Mode",		&RecSavMode},	// 0;CUT 1;PIC 2;GLM 3;BMP 4;JPEG 5;RGB
	{"Gray-Thres",		&GrayPoint},	// OCXP[̕~l
	{"Mono-Thres",		&MonoPoint},	// l̕~l
	{"Defocus-Point",	&DefocusPoint},	// ̒l
	0,0
};
struct	HENs {
	UNchar	*st;
	UNchar	*po;
} hens[]={
	{"Jpeg-Swc",		JpegSwc},
	{"Jpeg24-Swc",		Jpeg24Swc},
	{"Jpeg24-temp",		RGBtemp},
	0,0
};

//=== t@C[
/*struct  DDST {
	UNchar	fname[21];	//t@C
	UNchar	fext[6];	//gq(.)
	size_t	size;		//TCY
	int	date;		//t
	char	atr;		//
	//UNchar	fexm;		//gqm 0;ex1 1;ex2̊gq
};*/
struct	DDST DDS[256];
int	DDS_max;	/*obt@̐ -1ȂA} */

//UNchar	Afname[21];	/*Ώƃt@C*/
//UNchar	Afext[6];	/*Ώƃt@Cgq*/
UNchar	Apath[256];		/*ΏۃpX(JgpX)*/
UNchar	Afile[30];		/*Ώۃt@C*/
int	Drive;			/*1=A: 2=B: 	*/


UNchar	RSM[6][8]={			// 0;CUT 1;PIC 2;GLM 3;BMP 4;JPEG 5;RGB
		"*.CUT","*.PIC","*.GLM",
		"*.BMP","*.JPG","*.RGB"
};

UNchar	*mat_vadds;
int	mat_xwidth,mat_ywidth;

/*************************************************
	RtBOt@C
[in] na = t@C
	0 ȂftHg
[out] -1 ; G[
*************************************************/
int	CreateCnf(na)
char	*na;
{
int	i;
FILE	*fp;
UNchar	nb[256];
UNchar	buf[256];
UNchar	dmy[256];
if ( na==0 || *na==0 ){
	//-- S_TOOLŜpX
	struct	_psp *pd = _dos_getpdb();
	jstrcpy(nb,(char *)pd->exe_path);
	if ( jxscanner_==_JX250_ )
		jstrcat(nb,"S_TOOL25.CNF");	// JX250
	elif ( jxscanner_==_JX270_ )
		jstrcat(nb,"S_TOOL27.CNF");	// JX270
	elif ( jxscanner_==_JX350_ )
		jstrcat(nb,"S_TOOL35.CNF");	// JX350
	elif ( jxscanner_==_JX330_ )
		jstrcat(nb,"S_TOOL33.CNF");	// JX330
	elif ( jxscanner_==_JX325_ )
		jstrcat(nb,"S_TOOL32.CNF");	// JX325
	else	jstrcat(nb,"S_TOOL.CNF");
	na=nb;
}
if ( DrvAccess(1,na)!=0 )
	return(-1);
fp=fopen(na,"wt");
if ( fp==NULL )
	return(-1);
for(i=0;;i++){
	if ( hen[i].st==0 )
		break;
	sprintf(buf,"%-16s = %%d\n",hen[i].st);
	fprintf(fp,buf,*hen[i].po);
}
for(i=0;;i++){
	if ( hens[i].st==0 )
		break;
	sprintf(buf,"%-16s = %%s\n",hens[i].st );
	fprintf(fp,buf,hens[i].po);
}
if ( ferror(fp) ){
	//-- GĂ
	//	delete قH
	fclose(fp);
	return(-1);
}
fclose(fp);
return(0);
}
/*************************************************
	RtBOt@Cǂݍ
		ݒ肷
[in] na = t@C
	0 ȂftHg
[out] -1 ; G[
*************************************************/
int	ReadCnf(na)
char	*na;
{
int	i,j,l;
FILE	*fp;
UNchar	*s;
UNchar	nb[256];
UNchar	buf[1024];
UNchar	name[32];
if ( na==0 || *na==0 ){
	//-- S_TOOLŜpX
	struct	_psp *pd = _dos_getpdb();
	jstrcpy(nb,(char *)pd->exe_path);
	if ( jxscanner_==_JX250_ )
		jstrcat(nb,"S_TOOL25.CNF");	// JX250
	elif ( jxscanner_==_JX270_ )
		jstrcat(nb,"S_TOOL27.CNF");	// JX270
	elif ( jxscanner_==_JX350_ )
		jstrcat(nb,"S_TOOL35.CNF");	// JX350
	elif ( jxscanner_==_JX330_ )
		jstrcat(nb,"S_TOOL33.CNF");	// JX330
	elif ( jxscanner_==_JX325_ )
		jstrcat(nb,"S_TOOL32.CNF");	// JX330
	else	jstrcat(nb,"S_TOOL.CNF");
	na=nb;
}
if ( DrvAccess(0,na)!=0 )
	return(-1);
fp=fopen(na,"r");
if ( fp==NULL )
	return(-1);
JpegSwc[0]=0;
for(;;){
	j=(int)fgets(buf,1023,fp);
	if ( j==NULL )
		break;
	for(i=0;;i++){
		if ( hens[i].st==0 )
			break;
		if  ( sscanf(buf,"%s =",name)==1 && strcmp(hens[i].po,name)==0 ){
			s=name;
			while( *s++!='=' );
			while( *s==' ' )
				s++;
			strcpy(hens[i].po,s);
			s=hens[i].po;
			while( *s!=0 ){
				if ( ZenChk(*s) )
					s++;
				if ( *s==0xD || *s==0xA || *s==0x1A )
					*s=0;
				s++;
			}
			i=-1;
			break;
		}
	}
	if ( i<0 )
		continue;
	if  ( sscanf(buf,"%s = %d",name,&l)!=2 )
		continue;
	for(i=0;;i++){
		if ( hen[i].st==0 )
			break;
		if ( strcmp(hen[i].st,name)==0 ){
			//v
			*hen[i].po=l;
			break;
		}
	}
}
fclose(fp);
//--
//CalcScanDpi();
//--
if ( jxscanner==_JX350_ ){
	//jx350 ȂEEE
	if ( LightR==LightG && LightG==LightB ){
		;
	} else {
		LightR=LightG=LightB;
	}
	if ( LightR>=0x8000+600 ){
		LightR=LightG=LightB=0x8000+600;
	}
}
return(0);
}
/******************************************************
                  t@CT[`

	struct DDST {
		UNchar	fname[20];	//t@C
		UNchar	fext[6];	//gq(.)
		size_t	size;		//TCY
		int	date;		//t
	}

******************************************************/
void	FileSearch(mo)
int	mo;
{
int	m,n,z,nn,ol,ay;
char	demmy[150];
char	buf[256];
char	olpth[256];
char	*s;
char	path[16];
ay=-1;
ol=-1;
olpth[0]=0;
if ( FilerAllMode==0 ){
	// 0;֌Wt@Ĉݕ\
	jstrcpy(path,RSM[ RecSavMode ]);
} else {
	// 1;St@C\
	jstrcpy(path,"*.*");
}
ViewFileY=0;
if ( mo==0 ){
	Drive= GetDrvDir(Drive,Apath);
	ChDrvDir(Apath);
}
if ( (_dos_drvctrl(0,Drive)&bit(1))==0 ){
	/*}?*/
	DDS_max=-1;	/*obt@̐ -1ȂA} */
	return;
}
_dos_drvctrl(2,Drive);
/*-- fBNgT[` --*/
strsfn(Apath,demmy,buf,demmy,demmy);
//printf("%s\n",demmy);
if ( (buf[0]=='\\' && buf[1]==0) || buf[0]==0 ){
	//[g
	n=0;
} else {
	n=1;
	DDS[0].fname[0]='.';
	DDS[0].fname[1]='.';
	DDS[0].fname[2]=0;
	DDS[0].fext[0]=0;
	DDS[0].atr=bit(4);
}
for(z=nn=0,m=0;n<256;n++,m++){
	if ( m==0 )
		s= files(buf,&(DDS[n].atr),&(DDS[n].date),&(DDS[n].size),"*.*",bit(4));
	else	s=nfiles(buf,&(DDS[n].atr),&(DDS[n].date),&(DDS[n].size));
	if ( s==NULL )
		break;
	if ( s[0]=='.' && s[1]==0 ){
		n--;
		continue;
	}
	if ( s[0]=='.' && s[1]=='.' && s[2]==0 ){
		n--;
		z=1;
		continue;
		//DDS[n].fname[0]='.';
		//DDS[n].fname[1]='.';
		//DDS[n].fname[2]=0;
		//DDS[n].fext[0]=0;
	} else {
		strsfn(s,demmy,demmy,&(DDS[n].fname),&(DDS[n].fext));
	}
	//DDS[n].fexm=0;
}
DDS_sort(z,n-1,FilerSortMode);	// fBNgŃ\[g
/*-- t@C`FbN --*/
z=n;
for(nn=n,m=0;n<256;n++,m++){
	if ( m==0 )
		s= files(buf,&(DDS[n].atr),&(DDS[n].date),&(DDS[n].size),path,bit(5));
	else	s=nfiles(buf,&(DDS[n].atr),&(DDS[n].date),&(DDS[n].size));
	if ( s==NULL )
		break;
	strsfn(s,demmy,demmy,&(DDS[n].fname),&(DDS[n].fext));
	//DDS[n].fexm=0;
}
DDS_sort(z,n-1,FilerSortMode);
DDS_max=n;	/*obt@̐ -1ȂA} */
_dos_drvctrl(3,Drive);
}
/****************************************************
@@Jg𕶎̃hC^fBNgɂ
[߂l]hCio[( 1=A: 2=B: )
****************************************************/
int	ChDrvDir(st)
UNchar	*st;
{
int	i;
i=(st[0]|0x20)-'a';
if ( _dos_chgdrv(i)<i )	/*JghC`FW*/
	return( i+1 );
_dos_chdir(st);
return( i+1 );
}
/****************************************************
@@̃Jgǂ݂
[߂l]hCio[( 1=A: 2=B: )
****************************************************/
int	GetDrvDir(d,st)
int	d;
UNchar	*st;
{
if ( d<=0 )
	d=_dos_curdrv()+1;
st[0]='A'+d-1;
st[1]=':';
st[2]='\\';
st[3]=0;		// curdir G[̉\B
_dos_curdir(d,&st[3]);
if ( st[3]!=0 )
	jstrcat(&st[3],"\\");
return(d);
}
/****************************************************
@@t@C啔ƊgăRs[
****************************************************/
void	jstrcpyfnm(ss,fm,ex)
UNchar	*ss,*fm,*ex;
{
jstrcpy(ss,fm);
if ( ex[0]!=0 ){
	jstrcat(ss,".");
	jstrcat(ss,ex);
}
}
/*++*/
void	jstrcatfnm(ss,fm,ex)
UNchar	*ss,*fm,*ex;
{
jstrcat(ss,fm);
if ( ex[0]!=0 ){
	jstrcat(ss,".");
	jstrcat(ss,ex);
}
}

/***************************************************
               Fread(f,ad,ll)
[߂l] 0:퐬
	 G[
***************************************************/
char	*Fread(f,ad,ll)
int	f;
void	*ad;
int	ll;
{
int	r;
static	UNchar	fsm[]="t@CTCY܂";
static	UNchar	fwer[]="ǂݍ݃G[ł";
r=_dos_read(f,ad,ll);
if ( r<0 )
	return(fwer);	//ǂݍ݃G[
if ( r==ll )
	return((char*)0);
return(fsm);	//ǂݍ݃G[(Ȃ)
}
/***************************************************
               Fwrite(f,ad,ll)
[߂l] 0:퐬
	 G[
***************************************************/
char	*Fwrite(f,ad,ll)
int	f;
void	*ad;
int	ll;
{
int	r;
static	UNchar	erf[]="fBXNtł";
static	UNchar	er[]="݃G[ł";
r=_dos_write(f,ad,ll);
if ( r<0 )
	return(er);
if ( r==ll )
	return((char*)0);
return(erf);
}
/***************************************************
               Vt@CI[v
[߂l] 0:퐬
	-1:G[
***************************************************/
int	NewFileCreate()
{
int	f;
if ( DrvAccess(1,Afile)!=0 ){
	Dialog(0,"veNgĂ܂",0,1);
	return(-1);
}
f=_dos_open(Afile,0);
if ( f>=0 ){
	// t@C open ł
	_dos_close(f);
	if ( Dialog("t@C܂",0,"dˏ܂H",2)!=0 )
		return(-1);
}
f=_dos_create(Afile,bit(5));
return(f);
}
/***************************************************
		MAT.$$$ ǂݍ݃`FbN
[߂l] 0:퐬
***************************************************/
int	MatDefRead()
{
int	i;
FILE	*f;
UNchar	*s;
UNchar	buf[256];
UNchar	MAT[256];	//MATIER ̂pX
UNchar	dmi[512];
i=_dos_getenv("MATIER",0,MAT);			// ϐMATIER̒g𓾂
if ( i<0 ){
	printf(" ϐ`MATIER'ݒ肳Ă܂B\n");
	return(-1);
}
for(s=MAT;*s!=0;s++);
if ( *s-1!='\\' ){		//Ō\Ă邩H
	*s++='\\';
	*s=0;
}
strcat(MAT,"MAT.$$$");	//MAT.$$$̃tpXÂ͂
if ( DrvAccess(0,MAT)!=0 ){
	printf(	" ϐ`MATIER'̓ẽhCu͗pӂĂ܂B\n");
	return(-1);
}
f=fopen(MAT,"rt");
if ( f==NULL ){
	printf(	" MAT.$$$܂B\n"
		" ϐ`MATIER'̓eɌ肪\܂B\n"
	);
	return(-1);
}
while( fgets(buf,128,f)!=NULL ){
	if ( buf[0]=='V' && buf[1]==' ' ){
		sscanf(buf,"%s %p %d %d",dmi,&mat_vadds,&mat_xwidth,&mat_ywidth);
		break;
	}
}
fclose( f );
if ( (int)mat_vadds==0 ){
	printf(	" MATIER ŉzʂݒ肳ĂȂ悤łB\n");
	return(-1);
}
//printf(	" adds=%X,x=%d,y=%d\n",mat_vadds,mat_xwidth,mat_ywidth);
return(0);
}
/********************************************************
		̃hCu xx łH
[in] md=0 ; ANZXłH
	1 ; ݂łH
[out] 0 ; \
     -1 ; oȂ
********************************************************/
int	DrvAccess(md,st)
int	md;
UNchar	*st;
{
int	i,j,d;
UNchar	buf[256];
UNchar	dmy[256];
strsfn(st,buf,dmy,dmy,dmy);
d=((buf[0]|0x20)-'a');
if ( d<0 || d>26 )
	d=_dos_curdrv();
j=_dos_drvctrl(0,d+1);
//		printf("drive=%d  r=%02X\n",d,j);
if ( md==0 ){
	if ( (j&bit(1))!=0 && (j&bit(2))==0 )
		return(0);
} elif ( md==1 ){
	if ( (j&bit(1))!=0 && (j&bit(3))==0 )
		return(0);
}
return(-1);
}
/**************************************/
static	char	Dsof=1;	//~Ȃ畉̐
/*+++*/
/*---------|name|-----------*/
static	int	Dso_Name(D1,D2)
struct  DDST *D1,*D2;
{
int	j;
char	d1[21],d2[21];
j=jstrcmpi(D1->fname,D2->fname);
if ( j!=0 )
	return( (Dsof==1)?j:-j );
/*OȂgq*/
j=jstrcmpi(D1->fext,D2->fext);
return( (Dsof==1)?j:-j );
}
/*---------|exp|-----------*/
static	int	Dso_Ext(D1,D2)
struct  DDST *D1,*D2;
{
int	j;
char	d1[21],d2[21];
j=jstrcmpi(D1->fext,D2->fext);
if ( j!=0 )
	return( (Dsof==1)?j:-j );
/*gqȂ疼O*/
j=jstrcmpi(D1->fname,D2->fname);
return( (Dsof==1)?j:-j );
}
/*---------|size|-----------*/
static	int	Dso_Size(D1,D2)
struct  DDST *D1,*D2;
{
int i=D1->size;
int j=D2->size;
return( (i==j)?0:(i<j)?-Dsof:Dsof );
}
/*---------|date|-----------*/
static	int	Dso_Date(D1,D2)
struct  DDST *D1,*D2;
{
int i=D1->date;
int j=D2->date;
return( (i==j)?0:(i<j)? Dsof:-Dsof );
}
/*+++++++++++++++++++++++++++++*/
static	void	DDS_sort(s1,s2,sm)
int	s1,s2,sm;
{
static	(*foo[4])={Dso_Name,Dso_Date,Dso_Size,Dso_Ext};
//sm  =  1:name 2:date 3:TCY 4:exp (̐Ȃ~)
int	i,j,m,n,z;
int	b;
if ( sm==0 ) return;
if ( sm<0 ) {
	sm=-sm;
	Dsof=-1;	//~Ȃ畉̐
} else	Dsof=1;
sm--;
qsort( &DDS[s1],s2-s1+1,sizeof(struct  DDST),foo[sm] );
}
