/*
	TCg@o[W@version 1.04
	
	compiling :gcc -Wall -O2 -ldos sincomp4.c
	
						by SJOM
*/


#include <stdlib.h>
#include <stdio.h>
#include <sys/dos.h>
#include <math.h>


static char *message=
"		TCgvO	version 1.04
					ax@rinl
sinwave.x filename.p16 size(short int) 0(double) 0 1 1 2 2
	
	Vout=0sin(0t+1sin(1t+2sin(2t)))
	
";


static int size;
static short *sound_data;

static double alpha0,alpha1,alpha2;
static double omega0,omega1,omega2;



#define sampling_frequency	15625
	/* ADPCMpgBpɕς鎞́AύX邱ƁB
	@DbcE܁``ɂƁ@SSPOOO@*/

static void
make_sinwave(void)
{
	int loop;
	double data;
	double step,t=0,pai=3.141592653589793;
	
	for (loop=0;loop<size;loop++)
		sound_data[loop]=0;
	
	
	step=2*pai/((double)sampling_frequency);
/*
15625Hz -> 1sec 15625 short words
100Hz -> 15625/100=156.25 short words/wave
360=2 -> 2/156.25 radian/step
*/
	for (loop=0;loop<size;loop++) {
		data=alpha0*sin(omega0*t+alpha1*sin(omega1*t+alpha2*sin(omega2*t)));
		sound_data[loop]+=data;
		t+=step;
	};
	
	
}



int
main(int argc,char **argv)
{
	int fp;
	if (argc<8) {
		puts(message);
		exit(0);
	};
	size=atoi(*(argv+2)) & 0xfffffff;
	
	alpha0=atof(*(argv+3));
	omega0=atof(*(argv+4));
	alpha1=atof(*(argv+5));
	omega1=atof(*(argv+6));
	alpha2=atof(*(argv+7));
	omega2=atof(*(argv+8));
	
	
	sound_data=_dos_malloc(size*2);
	if ((void *)sound_data>=(void *)0x81000000) {
		puts("[sĂ܂B");
		exit(-1);
	};
	
	
	make_sinwave();
	
	_dos_delete(*(argv+1));
	fp=_dos_open(*(argv+1),0x001);
	if (fp<0) {
		fp=_dos_create(*(argv+1),0b100000);
		if (fp<0) {
			printf("%s:o̓t@CI[vo܂I\n",*(argv+2));
			exit(-1);
		};
		fp=_dos_open(*(argv+1),0x001);
	};
	_dos_seek(fp,0,0);
	_dos_write(fp,(void *)sound_data,size*2);
	_dos_close(fp);
	_dos_mfree(sound_data);
	exit(0);
}



